	device zxspectrum128
        ORG #6000
begin

	macro roto
	and 127
	add a,a
	bit 4,a
	jr z,.no_rot
	res 4,a
	set 0,a
.no_rot:
;	ld (hl),a
	endm

conn_up = 1;(0)
conn_right = 2;(1)
conn_down = 4;(2)
conn_left = 8;(3)

	ld a,$10,bc,$7ffd:out (c),a
	out ($FE),a
	ld sp,$FFFF

; little check
;	jr $
;	ld a,14
;	cp 15;CY=1
;	ld a,16
;	cp 15;CY=0
;	jr $
;build tiles adress,+32 to each
ta=#BD00
rndt=$BF00
chis=$B000
	ld hl,ta
	ld de,ts
bui:
	ld (hl),e:inc h
	ld (hl),d:dec h
	ex de,hl
	ld bc,32
	add hl,bc
	ex de,hl
	inc l
	jr nz,bui

;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
;menu
	call cls
	ld hl,(seed+1)
	ld de,seedm
	ld a,h
	call hn
	ld a,l
	call hn

printmnu:
;print text
	ld hl,texm
	call outex
	call outex
	call outex
	call outex
	call outex

;	ld ix,seedm ;   
kinp:
	ld a,$F7
	in a,($FE)
	bit 0,a:jp z,game_begin2 ; 1
	bit 1,a:jp z,kmou ; 2

	bit 3,a:jp nz,check_3 ; 4

	ld a,(mopt)
	xor 8
	ld (mopt),a

;	jr $
	ld a,(mopt+1)
	xor 70
	ld (mopt+1),a
	call wk
;	call keyp
	jp printmnu
check_3:
	bit 2,a:jr nz,kinp;3
; 
;	call wk
	ld ix,seedm
;	jp putc
;	ld a,$40+1+6*8,($5980+14),a
ks:
	push ix
	pop hl
	ld de,seedm;-1
	or a:sbc hl,de
	ld de,$5980+14;+1
	add hl,de
	ld (hl),$40+1+6*8

	call wk
	call keyp
;+Enter
	ld a,$BF:in a,($FE)
	and 1:jr nz,cshift

;convert ascii hex to number
	ld de,seedm
	ld b,4
	ld hl,0
hexlp:
	ld a,(de)
	cp $3A
	jr c,digi
;ABCDEF
	sub 7;add 65-48+10
digi:
;0-9
	sub "0"
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	or l
	ld l,a
	inc de
	djnz hexlp
	ld (seed+1),hl
	ld a,h:cp $BE:jr nz,no_cheat
	ld a,l:cp $EF:jr nz,no_cheat
	xor a:ld (cheat),a
	ld a,2:out ($FE),a
	ei:halt:halt:halt:halt
	xor a:out ($FE),a

no_cheat:
	ld hl,texm2
	call outex
	jp kinp

;CS
cshift:
	ld a,$fe:in a,($FE)
	and 1:jr nz,scanh
	ld (ix+0),"0"
	ld hl,texm2
	call outex
	ld a,(ix-1)
	cp "$":jp z,ks
	dec ix
	jp ks
scanh:
;scan 0-9,A-F
;check FF
	ld hl,kdata
	ld c,0
ks1:
	ld a,(hl):inc hl
	in a,($FE)
	cpl
	and (hl)
	jr nz,ex_ks
	inc hl
	inc c
	bit 4,c
	jr z,ks1
	jp ks;kinp
ex_ks:
	ld a,c
	cp 9+1
	jr c,no_7
	add a,7
no_7:
	add a,"0"
	
	ld (ix+0),a

	ld hl,texm2
	call outex

	ld a,(ix+1); 
	cp $FF
	jp z,ks
	inc ix

	jp ks
kdata: ;  
;0
	db $EF,1
;1
	db $F7,1
;2
	db $F7,2
;3
	db $F7,4
;4
	db $F7,8
;5
	db $F7,16
;6
	db $EF,16
;7
	db $EF,8
;8
	db $EF,4
;9
	db $EF,2
;A
	db $FD,1
;B
	db $7F,16
;C
	db $FE,8
;D
	db $FD,4
;E
	db $FB,4
;F
	db $FD,8

hn:
	push af
	srl a
	srl a
	srl a
	srl a
	call hexhum
	pop af
	and $0F
hexhum:
	cp 9+1
	jr c,no7
	add a,7
no7:
	add a,"0"
	ld (de),a:inc de
	ret

outex:
	ld e,(hl):inc hl
	ld d,(hl):inc hl
	ld a,(hl):inc hl
	ld (tca+1),a
oulp:
	ld a,(hl):inc hl
	cp $FF:ret z
	
	push hl
	ld l,a,h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,fnt-256
	add hl,bc
	push de
	ld b,8
ch8:
	ld a,(hl),(de),a
	inc hl,d
	djnz ch8
	pop de
;put text with color
	ld c,e
	ld a,d
	and %00011000
	srl a
	srl a
	srl a
	add a,$58
	ld b,a
tca:ld a,0
	ld (bc),a
;
	inc e
	pop hl
	jr oulp

wk:
	xor a
	in a,($fe)
	cpl
	and 31
	jr nz,wk
	ret
keyp:
	xor a
	in a,($FE)
	cpl
	and 31
	jr z,keyp
	ret

cls:
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr
	ret
white_screen:
	ld hl,$5800,de,$5801,bc,767,(hl),$47:ldir
	ret
;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
initmus:
;	jr $
	ld a,(mopt)
	cp "f":ret z
	ld hl,song:call INIT
	
	ld hl,$A000,de,$a001,(hl),$A1,bc,257:ldir
	di
	ld a,$A0,i,a
	im 2
	ld hl,intb,de,$a1a1,bc,inte-intb:ldir
	ei
	ret
game_begin2:
	call initmus
game_begin:
	call cls
;init variables
	ld de,$0608
	ld (cxy),de
;	call zerom
;zero memory
	ld hl,$C000
	xor a
zm1:
	ld (hl),a
	inc hl
	cp h
	jr nz,zm1

	call genl
	call copyl;copy level

	call rotl

;	ld de,$0607
;	call mapxy
;	ld a,(hl)
;	roto
;	ld (hl),a

	call checkrot
	call white_screen
	call drawl

glp:
	call cheat
	ld de,(cxy)
 ld a,$F7:in a,(#FE):and 16:jp z,left;5 is left
;O
 ld a,$DF:in a,(#FE):and 2:jp z,left

 ld a,$EF:in a,(#FE):and 4:jp z,right;8 is right
;P
 ld a,$DF:in a,(#FE):and 1:jp z,right

 ld a,$EF:in a,(#FE):and 8:jp z,up;7 is up
;Q
 ld a,$FB:in a,(#FE):and 1:jp z,up

 ld a,$EF:in a,(#FE):and 16:jp z,down;6 is down
;A
 ld a,$FD:in a,(#FE):and 1:jp z,down

; Fire
;0
	ld a,$EF:in a,($FE):and 1:jp z,fireon
;En
	ld a,$BF:in a,($FE):and 1:jp z,fireon
;Sp
	ld a,$7F:in a,($FE):and 1:jp z,fireon
;M
	ld a,$7F:in a,($FE):and 4:jp z,fireon

	jp glp
endk:
	ld (cxy),de
	call crs
	ei:halt:halt:halt:halt:halt
	jp glp
cxy: dw 0; DE=y,x
ccol=8
crs:
	push de
	ld de,(cxy)
	ld l,d
	add hl,hl
	add hl,hl;2
	add hl,hl;4
	ld h,11
	add hl,hl
	add hl,hl
	add hl,hl
	ld d,0
	add hl,de
	add hl,de
	push hl:pop ix
	ld a,(ix+0):xor ccol:ld (ix+0),a
	ld a,(ix+1):xor ccol:ld (ix+1),a
	ld a,(ix+32):xor ccol:ld (ix+32),a
	ld a,(ix+33):xor ccol:ld (ix+33),a
	pop de
	ret

left:
	ld a,e:or a:jp z,glp
	call crs
	dec e
	jp endk
right:
	ld a,e:cp 15:jp z,glp
	call crs
	inc e
	jp endk
up:
	ld a,d:or a:jp z,glp
	call crs
	dec d
	jp endk
down:
	ld a,d:cp 11:jp z,glp
	call crs
	inc d
	jp endk

fireon:
	call mapxy
	ld a,(hl)
	
	roto
;	and 127
;	add a,a
;	bit 4,a
;	jr z,norot
;	res 4,a
;	set 0,a
;norot:
	ld (hl),a
	call checkrot
	call drawl
	call crs
;count cells
	ei:halt:halt:halt
	call count_cells
	cp $C0
	jp nz,glp

	ld hl,twin
	call outex
	call wk
	call keyp

	jp game_begin
twin:
	dw #480C+4*32
	db $46
	db "Winner!",$FF

;;;;;;P R O C E D U R E S;;;;;;;;;;;;
count_cells:
	ld ixh,$C0
	ld c,0
ccy:
	ld ixl,0
ccx:
	bit 7,(ix+0):jr z,nocnt
	inc c
nocnt:
	inc ixl
	ld a,ixl
	and $0F:jp nz,ccx
	inc ixh
	ld a,ixh
	and $0F
	cp $0C
	jp nz,ccy
	ld a,c
	ret

zerom:;zero memory
	ld hl,$C000
	xor a
zm:
	ld (hl),a
	inc hl
	cp h
	jr nz,zm
	ret
mark: ;recursive fill
	call mapxy
	set 7,(hl)

mark_left:
;  If b(x,y)&#CONN_LEFT
	call mapxy
	bit 3,(hl)
	jr z,endml
;    If x>0
	ld a,e
	dec a
	jp m,endml
;      If b(x-1,y)&128=0 And b(x-1,y)&#CONN_RIGHT
	dec e
	call mapxy
	inc e
	bit 7,(hl):jp nz,endml
	bit 1,(hl):jp z,endml
;        pcell(x-1,y)
	dec e
	call mark
	inc e
;      EndIf
;    EndIf
;  EndIf
endml:
mark_right:
;  If b(x,y)&#CONN_RIGHT
	call mapxy
	bit 1,(hl)
	jr z,endmr
;    If x<15
	ld a,e
	inc a
	cp 15+1:jp nc,endmr
;      If b(x+1,y)&128=0 And b(x+1,y)&#CONN_LEFT
	inc e
	call mapxy
	dec e
	bit 7,(hl):jp nz,endmr
	bit 3,(hl):jp z,endmr
;        pcell(x+1,y)
	inc e
	call mark
	dec e
;    EndIf
;    EndIf
;  EndIf
endmr:
mark_up:
;  If b(x,y)&#CONN_UP
	call mapxy
	bit 0,(hl)
	jr z,endmu
;    If y>0
	ld a,d
	dec a
	jp m,endmu
;      If b(x,y-1)&128=0 And b(x,y-1)&#CONN_DOWN
	dec d
	call mapxy
	inc d
	bit 7,(hl):jp nz,endmu
	bit 2,(hl):jp z,endmu
;        pcell (x,y-1)
	dec d
	call mark
	inc d
;      EndIf
;    EndIf
;  EndIf
endmu:
;conn_up = 1;(0)
;conn_right = 2;(1)
;conn_down = 4;(2)
;conn_left = 8;(3)
mark_down:
;  If b(x,y)&#CONN_DOWN
	call mapxy
	bit 2,(hl)
	jr z,endmd
;    If y<12
	ld a,d
	inc a
	cp 12:jp nc,endmd
;      If b(x,y+1)&128=0 And b(x,y+1)&#CONN_UP
	inc d
	call mapxy
	dec d
	bit 7,(hl):jp nz,endmd
	bit 0,(hl):jp z,endmd
;        pcell(x,y+1)
	inc d
	call mark
	dec d
;        EndIf
;    EndIf
;  EndIf
endmd:
	ret
checkrot:;checked connections
;reset connected
	ld ixh,$C0
resy:
	ld ixl,0
resx:
	res 7,(ix+0)
	inc ixl
	ld a,ixl
	and $0F
	jp nz,resx
	inc ixh
	ld a,ixh
	and $0F
	cp $0C
	jp nz,resy
	
	ld de,$0608:call mark;DE=y.x
	ret
rotl: ; rotate tiles
;  For y=0 To 11
;    For x=0 To 15
;      j=Random(20)+1
;      For i=0 To j
;        p=b(x,y)<<1
;        If p&16
;          p|1
;          p&15
;        EndIf
;        b(x,y)=p
;      Next i
;    Next x
;  Next y
	ld ixh,$C0
roty:
	ld ixl,0
rotx:
	ld a,20
	call rndn
	inc a
	ld b,a

	ld a,(ix+0)
	and 127
rotlp:
	add a,a
	bit 4,a
	jr z,noroto
	res 4,a
	set 0,a
noroto:
	djnz rotlp
	ld (ix+0),a
	inc ixl
	ld a,ixl
	and $0F
	jp nz,rotx
	inc ixh
	ld a,ixh
	and $0F
	cp $0C
	jp nz,roty
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pscore ds 8
prseed:
	ld de,pscore
	ld a,h
	call hn
	ld a,l
	call hn

	ld de,$5900
chgo:
	ld hl,pscore
	ld a,128,(chb+1),a
	ld b,4

ch5:
	push hl
	ld l,(hl)
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	push bc
	ld bc,fnt-256
	add hl,bc
	pop bc
	
ch_letr:
	push de
	push hl
	ld c,8
ch_8:
	ld a,(hl)
chb: and 128
	jr z,chput
chco:	ld a,3*9
chput:
	ld (de),a
	ld a,e:add a,32:ld e,a
	ld a,d:adc a,0:ld d,a
	inc hl
	dec c:jr nz,ch_8
	
	pop hl,de
	inc e
	ld a,(chb+1)
	srl a
	ld (chb+1),a
	jp nc,ch_letr
	ld a,128,(chb+1),a
	pop hl:inc hl
	djnz ch5
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
prevs: dw 0
drawl: ; drawlevel
	ld de,$4000
	ld ixh,$C0
drly:
	ld ixl,0
drlx:
	ld a,(ix+0)
	and $0F
	ld l,a
	ld h,ta/256
	ld a,(hl):inc h
	ld h,(hl),l,a
	
	ld b,16
	push de
drtl:
	ld a,(hl),(de),a:inc hl,e
	ld a,(hl),(de),a:inc hl:dec e
	call nbde
	djnz drtl
	pop de
; attributes
;: DE=
;: HL= 
;$40=010 00 000
;$48=010 01 000
;$50=010 10 000

;$58=010110 00
;$59=010110 01
;$5A=010110 10
	ld a,d
	and %000111000
	rra
	rra
	rra
	add a,$58
	ld h,a
	ld l,e
	
	ld a,2
	bit 7,(ix+0)
	jr z,notc
	ld a,4
notc:
;	jr $
	ld c,a,b,%11111000
	ld a,(hl):and b:or c:ld (hl),a;ld (hl),a
	inc hl
	ld a,(hl):and b:or c:ld (hl),a;ld (hl),a
	;;ld bc,31:add hl,bc
		ld a,l:add a,31:ld l,a
		ld a,h:adc a,0:ld h,a
	
	ld a,(hl):and b:or c:ld (hl),a;ld (hl),a
	inc hl
	ld a,(hl):and b:or c:ld (hl),a;ld (hl),a

;
	inc e,e
	inc ixl
	ld a,ixl
	and $0F:jp nz,drlx
;down line
	ld a, e:add a,32:ld e,a
	sbc a,a:and 8
	add a,d:ld d,a
	inc ixh
	ld a,ixh
	and $0F
	cp $0C
	jp nz,drly
op1:	call crs
	ret
nbde    INC D:LD A,D:AND 7:RET NZ
        LD A,E:ADD A,#20:LD E,A:RET C
        LD A,D:SUB 8:LD D,A:RET

mapxy: ; DE=y.x,HL=addr
	ld l,e
	ld a,d
	or $C0
	ld h,a
	ret

shiftdir: ; A=1<<d,A=d
	push bc
	ld b,a
	ld a,1
	inc b:dec b:jr z,endsft;B=0?
elp:
	add a,a
	djnz elp
endsft:
	pop bc
	ret
genl: ; generate level
	ld hl,(seed+1),(prevs),hl
	call prseed

;	jr $
;  b(Random(15),Random(11))=1<<(Random(3))
	call random
	and 15
	ld e,a

	ld (chis),a
	
	ld a,12
	call rndn
	ld (chis+256),a
	ld d,a
	call mapxy
	call random
	and 3
	call shiftdir
; ,  DEDA   
;	ld (hl),a

;  ca.l=1;cell amount
	ld ixl,1

	ld a,9*6,($5800),a
grpt1:
;  Repeat
	ld h,$58
	ld a,ixl
	;dec a
	ld l,a
	ld (hl),9*6

	ld a,ixl
	call rndn
	ld h,chis/256
	ld l,a
	ld e,(hl):inc h:ld d,(hl)
;;;grpt2:
;;;;    Repeat
;;;;      xp.l=Random(15)
;;;;      yp.l=Random(11)
;;;	call random
;;;	and 15
;;;	ld e,a
;;;	ld a,12
;;;	call rndn
;;;	ld d,a
;;;	call mapxy
;;;;    Until b(xp,yp)
;;;	ld a,(hl)
;;;	or a:jr z,grpt2

;    direction.l=1<<(Random(3)
	call random
	and 3
	call shiftdir
	ld b,a
;    reverseDirection.l=0
	ld c,0
	
	push de
	exx
	pop de
	exx;DE=yp2.xp2,DE'=yp.xp

;    Select direction
	bit 0,b:jp nz,case_up;UP=1
	bit 1,b:jp nz,case_right;right=2
	bit 2,b:jp nz,case_down;down=4
	bit 3,b:jp nz,case_left;left=8

	ld a,4:out ($FE),a
	jr $


;      Case #CONN_UP:
case_up:
;        xp2.l=xp
;        yp2.l=yp-1
;        If yp2<0 Or yp2>=12
	ld a,d
;;	dec a:jp m,endcase1
	or a:jp z,endcase1
	;cp 12:jp c,endcase1
	dec d;;ld d,a
	ld c,conn_down
	jp endcase1
;        Else
;          reverseDirection = #CONN_DOWN
;        EndIf
case_down:
;      Case #CONN_DOWN:
;        xp2.l=xp
;        yp2.l=yp+1
;        If yp2<0 Or yp2>=12
	ld a,d
	inc a
	cp 12:jp nc,endcase1
	ld d,a
	ld c,conn_up
	jp endcase1
;        Else
;          reverseDirection = #CONN_UP
;        EndIf
case_left:
;      Case #CONN_LEFT:
;        xp2.l=xp-1
;        yp2.l=yp
;        If xp2<0 Or xp2>=16
	ld a,e
;;	dec a
	or a:jp z,endcase1
;;	jp m,endcase1
;;	ld e,a
	dec e
	ld c,conn_right
	jp endcase1
;        Else
;          reverseDirection = #CONN_RIGHT
;        EndIf
case_right:
;      Case #CONN_RIGHT:
;        xp2.l=xp+1
;        yp2.l=yp
;        If xp2<0 Or xp2>=16
	ld a,e
	inc a
	cp 15+1:jp nc,endcase1
	ld e,a
	ld c,conn_left
;        Else
;          reverseDirection = #CONN_LEFT
;        EndIf
endcase1:
;DE=yp2.xp2,DE'=yp.xp
;    If reverseDirection<>0 And b(xp2,yp2)=0;if (p2 != null && p2.getConnections() == 0)
	ld a,c:or a:jp z,endif1
	call mapxy
	ld a,(hl):or a:jp nz,endif1
;	jr $
;      b(xp2,yp2)=b(xp2,yp2)|reverseDirection;                 p2.setConnected(reverseDirection, true);
	or c:ld (hl),a
;put to chis
	ld h,chis/256
	ld a,ixl
	ld l,a
	ld (hl),e:inc h:ld (hl),d
	
;	jr $
;	ld (cxy),de
;	push bc,ix
;	call crs
;	pop ix,bc
;	ei:halt

;      ca+1
	inc ixl
;      b(xp,yp)=b(xp,yp)|direction;                 p.setConnected(direction, true);
	ld a,b
	exx
	push af
	call mapxy
	pop af
	or (hl):ld (hl),a
	exx

;      b(xp2,yp2)=b(xp2,yp2)|reverseDirection;                 p2.setConnected(reverseDirection, true);
;	call mapxy
;	ld a,(hl):or c:ld (hl),a
;    EndIf
endif1:
;  Until ca=192
	ld a,ixl
	cp 192:jp nz,grpt1

	ret
rndn: ; A=random(0..N-1)
	or a:ret z
	push hl,bc
	ld c,a
	call random
	ld b,a;number
	ld hl,rndt;$Bf00
	xor a
flt:
	ld (hl),a
	inc a
	cp c
	jr nz,norange
	xor a
norange:
	inc l:jr nz,flt
	ld l,b,a,(hl)
	pop bc,hl
	ret
random:
	push hl,de
seed:  ld hl,12345;$ded6;
  ; hl ^= hl << 5
  ld d,h
  ld a,l
  add hl,hl
  add hl,hl
  add hl,hl
  add hl,hl
  add hl,hl
  xor l
  ld l,a
  ld a,d
  xor h
  ld h,a
  ; hl ^= hl >> 9
  rra
  xor l
  ld l,a
  ; hl ^= hl <<8
  xor h
  ld h,a
  ld (seed+1),hl
  ld a,h
  pop de,hl
  ret

ts:incbin "pipet1.bin"
fnt:incbin "avant.fnt"

texm:
	dw #4800
	db $47
	db "1.Control:Keyboard(qaopm,cursor)",$FF

	dw #4840
	db $47
	db "2.Control:Kempston mouse",$FF

texm2:
	dw #4880
	db $47
	db "3.Input seed:$"
seedm: db "1A39"
	db $FF

	dw #48C0
	db $47
	db "4.Music:o"
mopt: db "n "
	db $FF

	dw #50E7
	db $46
	db "code:g0blinish,2018",$FF

;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
kmou:
	ld a,$21,(op1),a;block call crs
	call initmus
kmouse:
;zero memory
	ld hl,$C000
	xor a
zm2:
	ld (hl),a
	inc hl
	cp h
	jr nz,zm2

	call cls
	call genl
	call copyl;copy level
	call rotl

;	ld de,$0607
;	call mapxy
;	ld a,(hl)
;	roto
;	ld (hl),a

	call checkrot
	call white_screen
	call drawl

	ld hl,$5F7F
	ld (mousexy),hl
;wk:
;	xor a
;	in a,($FE)
;	cpl
;	and 31
;	jr z,wk

	call saveplace;+cursordraw
kl
	ei:halt
	call cheat
	call restoredata
	call getmouse;
	call saveplace;+cursordraw

;#FADF - ,       ,  
;          0,   :  D0-, D1-,
;        D2-.

	ld	bc, 0FADFh
	in	a, (c)
	bit 1,a;0- for left
	jp nz,kl
;
	call restoredata
	ld de,(mousexy)
	ld a,d
	sub ymin
	srl a
	srl a
	srl a
	srl a
	ld d,a

	ld a,e
	sub xmin
	srl a
	srl a
	srl a
	srl a
;	inc a
	ld e,a

	call mapxy
	ld a,(hl)
	roto
	ld (hl),a
	
	call checkrot
	call drawl

	call count_cells
	cp $C0
	jp nz,wlb

	ld hl,twin
	call outex
	
	ld b,50
dela:
	ei:halt
	djnz dela
;	call wk
;	call keyp

	jp kmouse

wlb:
	ld	bc, 0FADFh
	in	a, (c)
	bit 1,a;0- for left
	jr z,wlb
;
	call saveplace;+cursordraw
	jr kl

saveplace:
		ld	de, (mousexy);coords
		ld	a, d
		or	a
		jr	z, zeroy
		dec	d
zeroy:

		ld	a, e
		or	a
		jr	z, zerox
		dec	e
; 
zerox:
		ld	a, d
		rra
		scf
		rra
		rra
		and	5Fh
		ld	h, a
		xor	e
		and	7
		xor	e
		rrca
		rrca
		rrca
		ld	l, a
		ld	a, d
		xor	h
		and	7
		xor	h
		ld	h, a
		ld	(cursoradr), hl
		cp	58h
		ret	nc
		push	hl
		ld	de, storebuf
		ld	bc, 10FFh

copyd:
		ldi
		ldi
		dec	hl
		dec	hl
		call	downhl
		djnz	copyd
		pop	hl
		ld	a, (mousexy)
		sub	1
		jr	c, bra4
		and	7
bra4:
		sub	8
		neg
		ld	b, a
		ld	de, cursormask
		ld	c, 10h
		ld	a, (mousexy+1)
		or	a
		jr	nz, bra3
		inc	de
		inc	de
		dec	c
bra3:
		ex	de, hl
		push	bc
		push	hl
		push	de
		ld	e, (hl)
		ld	d, 0FFh
		inc	hl
		ld	l, (hl)
		ld	h, 0

crs_shft:
		db $CB,$33;sll	e or E=E*2+1
		rl	d
		add	hl, hl
		djnz	crs_shft

		ld	b, h
		ld	c, l
		pop	hl
		ld	a, (hl)
		and	d
		or	b
		ld	(hl), a
		inc	l
;		ld	a, l
;		and	1Fh
;		jr	z, redge
		ld	a, (hl)
		and	e
		or	c
		ld	(hl), a
redge:
		dec	l
		call	downhl
		pop	de
		pop	bc
		inc	de
		inc	de
		ld	a, h
		cp	58h
		ret	nc
		dec	c
		jr	nz, bra3
		ret

restoredata:
		ld	hl, (cursoradr)
		ld	de, storebuf
		ld	b, 10h

copy2:
		ld	a, h
		cp	58h
		ret	nc
		ld	a, (de)
		ld	(hl), a
		inc	hl
		inc	de
		ld	a, (de)
		ld	(hl), a
		inc	de
		dec	hl
		call	downhl
		djnz	copy2
		ld	h, 58h
		ld	(cursoradr), hl
		ret

downhl:
		inc	h
		ld	a, h
		and	7
		ret	nz
		ld	a, l
		add	a, 20h ; ' '
		ld	l, a
		ret	c
		ld	a, h
		sub	8
		ld	h, a
		ret
; ---------------------------------------------------------------------------
mdataxy:
		db 0,0

getmouse:
		ld	hl, (mousexy);coords
		ld	de, (mdataxy)

;#FBDF -  
		ld	bc, 0FBDFh
		in	a, (c)

		ld	(mdataxy), a

		sub	e
		jr	z, end_check_x
		jp	p, bra1
		add	a, l
		jr	c, xleft
		xor	a
xleft:
		ld	l, a
		jr	end_check_x

;  
xmax=255-8
;loc_641E:
bra1:
		add	a, l

		jr	c, xright
		cp	xmax
		jr	c, donex
xright:
		ld	a, xmax
donex:
		ld	l, a

end_check_x:

;#FFDF -  
		ld	b, 0FFh
		in	a, (c)

		ld	(mdataxy+1), a;Y
		sub	d
		jr	z, end_check_y
		neg
		jp	p, bra2
		add	a, h
		jr	c, yup
		xor	a
yup:
		ld	h, a
		jr	end_check_y
; ---------------------------------------------------------------------------
ymax=192

bra2:
		add	a, h
		jr	c, ybot
		cp	ymax
		jr	c, doney
ybot:
		ld	a,ymax
doney
		ld	h, a

end_check_y:
;     
ymin=1;33
		ld a,h
		cp	ymin
		jr	nc, smaly
		ld	a, ymin
smaly:
		ld	h, a
		ld a,l
xmin=4;49
		cp	xmin
		jr	nc, smalx
		ld	a, xmin
smalx:
		ld l,a
		ld	(mousexy), hl
		ret
; ---------------------------------------------------------------------------

storebuf:
	ds 64


mousexy:
	dw 5F7Fh;mousexy Y.X

cursoradr: dw 0

cursormask:
		db 0BFh
		db    0
		db  1Fh
		db  40h
		db  1Fh
		db  40h
		db  0Fh
		db  60h
		db  0Fh
		db  60h
		db    7
		db  50h
		db    7
		db  50h
		db    3
		db  48h
		db    3
		db  48h
		db  11h
		db  44h
		db  11h
		db  44h
		db    0
		db  4Eh
		db    1
		db  70h
		db  0Fh
		db  40h
		db 0BFh
		db    0
		db 0FFh
		db    0
song: incbin "COSMIX_22.pt3"
plyr: include "PTxPlay.a80"
intb:
	push ix,iy
	push hl,de,bc,af
	exx:exa
	push hl,de,bc,af
	call PLAY
	pop af,bc,de,hl
	exx:exa
	pop af,bc,de,hl
	pop iy,ix
	ei:ret
inte:
swapl: ; swap level
	ld ixh,$C0
sway:
	ld ixl,0
swax:
	ld c,(ix+0)
	ld a,(ix+64)
	ld (ix+64),c
	ld (ix+0),a
	inc ixl
	ld a,ixl
	and $0F:jp nz,swax
	inc ixh
	ld a,ixh
	and $0F
	cp $0C
	jp nz,sway
	ret

copyl: ; copy level
	ld ixh,$C0
coly:
	ld ixl,0
colx:
	ld a,(ix+0),(ix+64),a
	inc ixl
	ld a,ixl
	and $0F:jp nz,colx
	inc ixh
	ld a,ixh
	and $0F
	cp $0C
	jp nz,coly
	ret
cheat:
 ret
	ld a,$BF
	in a,($FE)
	and 16
	ret nz
w_h:
;	jr $
	ld a,$BF
	in a,($FE)
	and 16
	jr z,w_h
	ei:halt
	call swapl
	call drawl
	call keyp;wk
	call swapl
	call drawl
 ret
end
	display /d,end-begin
	savesna "!void.sna",begin
	savebin "pipes.code",begin,end-begin
